
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Workflow_stepsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const workflow_steps = await db.workflow_steps.create(
            {
                id: data.id || undefined,
        
        step_no: data.step_no
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        decision_type: data.decision_type
        ||
        null
            ,
            
        is_mandatory: data.is_mandatory
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await workflow_steps.setWorkflow( data.workflow || null, {
            transaction,
        });
        
        await workflow_steps.setApprover_role( data.approver_role || null, {
            transaction,
        });
        

        

        

        return workflow_steps;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const workflow_stepsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                step_no: item.step_no
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                decision_type: item.decision_type
            ||
            null
            ,
            
                is_mandatory: item.is_mandatory
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const workflow_steps = await db.workflow_steps.bulkCreate(workflow_stepsData, { transaction });

        // For each item created, replace relation files
        

        return workflow_steps;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const workflow_steps = await db.workflow_steps.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.step_no !== undefined) updatePayload.step_no = data.step_no;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.decision_type !== undefined) updatePayload.decision_type = data.decision_type;
        
        
        if (data.is_mandatory !== undefined) updatePayload.is_mandatory = data.is_mandatory;
        
        
        updatePayload.updatedById = currentUser.id;

        await workflow_steps.update(updatePayload, {transaction});

        
        
        if (data.workflow !== undefined) {
            await workflow_steps.setWorkflow(
              
              data.workflow,
              
              { transaction }
            );
        }
        
        if (data.approver_role !== undefined) {
            await workflow_steps.setApprover_role(
              
              data.approver_role,
              
              { transaction }
            );
        }
        

        
        

        

        return workflow_steps;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const workflow_steps = await db.workflow_steps.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of workflow_steps) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of workflow_steps) {
                await record.destroy({transaction});
            }
        });


        return workflow_steps;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const workflow_steps = await db.workflow_steps.findByPk(id, options);

        await workflow_steps.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await workflow_steps.destroy({
            transaction
        });

        return workflow_steps;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const workflow_steps = await db.workflow_steps.findOne(
            { where },
            { transaction },
        );

        if (!workflow_steps) {
            return workflow_steps;
        }

        const output = workflow_steps.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.voucher_approvals_workflow_step = await workflow_steps.getVoucher_approvals_workflow_step({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        output.workflow = await workflow_steps.getWorkflow({
            transaction
        });
        
        
        output.approver_role = await workflow_steps.getApprover_role({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.approval_workflows,
        as: 'workflow',
        
        where: filter.workflow ? {
          [Op.or]: [
            { id: { [Op.in]: filter.workflow.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.workflow.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.roles,
        as: 'approver_role',
        
        where: filter.approver_role ? {
          [Op.or]: [
            { id: { [Op.in]: filter.approver_role.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.approver_role.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'workflow_steps',
                        'title',
                        filter.title,
                    ),
                };
            }
            

            
            

            
            if (filter.step_noRange) {
                const [start, end] = filter.step_noRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    step_no: {
                    ...where.step_no,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    step_no: {
                    ...where.step_no,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.decision_type) {
                where = {
                    ...where,
                decision_type: filter.decision_type,
            };
            }
            
            if (filter.is_mandatory) {
                where = {
                    ...where,
                is_mandatory: filter.is_mandatory,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.workflow_steps.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'workflow_steps',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.workflow_steps.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

